<?php
/**
 * Templates Name: Elementor
 * Widget: Menu Nav
 */

$settings = $this->get_settings_for_display();

extract($settings);

$active_ajax = false;

$available_menus = $this->get_available_menus();

if (!$available_menus || empty($menu) || !is_nav_menu($menu)) {
    return;
}

$_id = besa_tbay_random_key();

$args = [
    'echo'        => false,
    'menu'        => $menu,
    'container_class' => 'collapse navbar-collapse',
    'menu_id'     => 'menu-' . $this->get_nav_menu_index() . '-' . $_id,
    'walker'      => new Besa_Tbay_Nav_Menu(),
    'fallback_cb' => '__return_empty_string',
    'container'   => '',
    'items_wrap'  => '<ul id="%1$s" class="%2$s" data-id="'. $menu .'">%3$s</ul>'
];

$args['menu_class'] = besa_nav_menu_get_menu_class($layout);


// General Menu.
$menu_html = wp_nav_menu($args);

// Dropdown Menu.
$args['menu_id'] = 'menu-' . $this->get_nav_menu_index() . '-' . $this->get_id();

if (empty($menu_html)) {
    return;
}

$this->add_render_attribute(
    'main-menu',
    [
        'class' => [
            'tbay-nav-menu-' .$this->get_id(),
            'elementor-nav-menu--main',
            'elementor-nav-menu__container',
            'elementor-nav-menu--layout-' . $layout,
            'tbay-'.$layout,
        ],
        'data-id' => $menu
    ]
);

if ($layout === 'vertical' || $layout === 'treeview') {
    $this->add_render_attribute('main-menu', 'class', 'tbay-treevertical-lv1');
}

if ($show_toggle_menu && !empty($toggle_content_menu)) {
    $this->add_render_attribute('wrapper', 'class', 'category-inside');
}


if ($layout === 'vertical') {
    if (isset($toggle_vertical_submenu_align) && empty($toggle_vertical_submenu_align)) {
        $toggle_vertical_submenu_align = 'left';
    }

    if ($show_canvas_menu === 'yes') {

        if ($toggle_canvas_content_align === 'left') {
            $toggle_vertical_submenu_align = 'right';
        } else {
            $toggle_vertical_submenu_align = 'left';
        }
    }

    $this->add_render_attribute('main-menu', 'class', 'vertical-submenu-'.$toggle_vertical_submenu_align);
}

$toggle_show_content = false;
if ($show_content_menu === 'yes' && besa_tbay_is_home_page() && !is_home()) {
    $this->add_render_attribute('wrapper', 'class', ['open' ,'setting-open']);
    $toggle_show_content = true;
}

if ($show_toggle_menu) {
    $content_class = $this->add_render_attribute('content-class', 'class', 'category-inside-content');

    if ($toggle_content_menu === 'yes' && $ajax_toggle === 'yes' && !$toggle_show_content) {
        $this->add_render_attribute('wrapper', 'class', ['element-menu-ajax', 'ajax-active']);
        $active_ajax = true;
    }
} elseif ($show_canvas_menu) {
    $this->add_render_attribute('wrapper', 'class', 'element-menu-canvas');
    $content_class = $this->add_render_attribute('content-class', 'class', 'menu-canvas-content');

    if (isset($ajax_canvas) && $ajax_canvas === 'yes') {
        $this->add_render_attribute('wrapper', 'class', ['element-menu-ajax', 'ajax-active']);
        $active_ajax = true;
    }
}

if (isset($show_canvas_menu) && $show_canvas_menu === 'yes') {
    $type_menu = 'canvas';
} elseif (isset($show_toggle_menu) && $show_toggle_menu === 'yes') {
    $type_menu = 'toggle';
} else {
    $type_menu = 'none';
}

$this->add_render_attribute(
    'wrapper',
    [
        'data-wrapper' => wp_json_encode([
            'layout' => $layout,
            'type_menu' => $type_menu
        ]),
    ]
);

?>
<div <?php $this->print_render_attribute_string('wrapper'); ?>>
	<?php $this->print_render_get_toggle_menu(); ?>
	
	<?php $this->print_render_canvas_button_menu(); ?>

	<?php if ($show_toggle_menu || $show_canvas_menu) {
	    echo '<div '. $this->get_render_attribute_string('content-class') .' >';
	} ?>
		<?php $this->print_render_get_toggle_canvas_menu(); ?>
		<nav <?php $this->print_render_attribute_string('main-menu'); ?>>
			<?php
                if (!$active_ajax) {
                    echo trim($menu_html);
                }
?>
		</nav>
	<?php if ($show_toggle_menu || $show_canvas_menu) {
	    echo '</div>';
	} ?>

</div>